/////////////////////////////////////////////////
// This file is part of Sears project.
// Subtitle Editor And Re-Synch
// A tool to easily modify and resynch movies subtitles.
/////////////////////////////////////////////////
//This program is free software; 
//you can redistribute it and/or modify it under the terms 
//of the GNU General Public License 
//as published by the Free Software Foundation; 
//either version 2 of the License, or (at your option) any later version.
/////////////////////////////////////////////////
//Sears project is available under sourceforge
// at adress: http://sourceforge.net/projects/sears/
//Copyright (C) 2005 Booba Skaya
//Mail: booba.skaya@gmail.com
////////////////////////////////////////////////
package sears.gui;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.util.Hashtable;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeListener;

import sears.tools.Utils;


/**
 * Class JPanelVideoControler.
 * <br><b>Summary:</b><br>
 * This is the panel that permits to control the video player.
 */
public class JPanelVideoControler extends JPanel {
    private static final long serialVersionUID = 1L;
    private JButton jButtonOpenVideo = null;
    private JButton jButtonStop = null;
    private JButton jButtonPlay = null;
    private JButton jButtonPrevious = null;
    private JSpinner jSpinnerTimeStep = null;
    private JButton jButtonNext = null;
    private JSlider jSliderSearch = null;
    private JCheckBox jCheckBoxTrackMode = null;
    private JPanel jPanelStopPlay = null;
    private JPanel jPanelPreviousNext = null;
    private JButton jButtonPause = null;
    private JLabel jLabelTime = null;

    /**
     * This is the default constructor
     */
    public JPanelVideoControler() {
        super();
        initialize();
    }

    /**
     * This method initializes this
     */
    private void initialize() {
        GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
        gridBagConstraints9.gridx = 4;
        gridBagConstraints9.anchor = GridBagConstraints.EAST;
        gridBagConstraints9.gridy = 0;

        GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
        gridBagConstraints7.gridx = 0;
        gridBagConstraints7.gridy = 0;
        gridBagConstraints7.fill = GridBagConstraints.NONE;
        gridBagConstraints7.anchor = GridBagConstraints.WEST;
        
        gridBagConstraints7.insets = new Insets(5, 0, 5, 0);
        gridBagConstraints7.gridwidth = 2;
        
        GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
        gridBagConstraints6.gridx = 5;
        gridBagConstraints6.anchor = GridBagConstraints.EAST;
        gridBagConstraints6.gridy = 0;
        GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
        gridBagConstraints5.fill = GridBagConstraints.BOTH;
        gridBagConstraints5.gridy = 2;
        gridBagConstraints5.weightx = 1.0;
        gridBagConstraints5.gridwidth = 7;
        gridBagConstraints5.gridx = 0;
        GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
        gridBagConstraints8.fill = GridBagConstraints.VERTICAL;
        gridBagConstraints8.gridy = 0;
        gridBagConstraints8.weightx = 1.0;
        gridBagConstraints8.gridwidth = 3;
        gridBagConstraints8.anchor = GridBagConstraints.CENTER;
        gridBagConstraints8.gridx = 2;
        this.setSize(563, 62);
        this.setBorder(BorderFactory.createEmptyBorder(5, 10, 5, 10));
        this.setLayout(new GridBagLayout());
        this.add(getJSliderSearch(), gridBagConstraints5);
        this.add(getJCheckBoxTrackMode(), gridBagConstraints6);
        this.add(getJPanelStopPlay(), gridBagConstraints7);
        this.add(getJPanelPreviousNext(), gridBagConstraints8);
        this.add(getJLabelTime(), gridBagConstraints9);
        
    }

    /**
     * This method initializes jButtonOpenVideo	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getJButtonOpenVideo() {
        if (jButtonOpenVideo == null) {
        	jButtonOpenVideo = new JButton(MainWindow.instance.getAction(MainWindow.ACTION_KEY_SELECT_VIDEO));
        	jButtonOpenVideo.setText("");
        }
        return jButtonOpenVideo;
    }

    /**
     * This method initializes jButtonStop	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getJButtonStop() {
        if (jButtonStop == null) {
            jButtonStop = new JButton(MainWindow.instance.getAction(MainWindow.ACTION_KEY_STOP));
            jButtonStop.setText("");
        }
        return jButtonStop;
    }

    /**
     * This method initializes jButtonPlay	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getJButtonPlay() {
        if (jButtonPlay == null) {
            jButtonPlay = new JButton(MainWindow.instance.getAction(MainWindow.ACTION_KEY_PLAY));
            jButtonPlay.setText("");
        }
        return jButtonPlay;
    }

    /**
     * This method initializes jButtonPrevious	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getJButtonPrevious() {
        if (jButtonPrevious == null) {
            jButtonPrevious = new JButton(MainWindow.instance.getAction(MainWindow.ACTION_KEY_PREVIOUS));
            jButtonPrevious.setText("");
        }
        return jButtonPrevious;
    }

    /**
     * This method initializes jSpinner	
     * 	
     * @return javax.swing.jSpinner	
     */
    private JSpinner getJSpinnerTimeStep() {
        if (jSpinnerTimeStep == null) {
            jSpinnerTimeStep = new JSpinner(new SpinnerNumberModel(10, 1, 200, 1));
        }
        return jSpinnerTimeStep;
    }

    /**
     * This method initializes jButtonNext	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getJButtonNext() {
        if (jButtonNext == null) {
            jButtonNext = new JButton(MainWindow.instance.getAction(MainWindow.ACTION_KEY_NEXT));
            jButtonNext.setText("");
        }
        return jButtonNext;
    }

    /**
     * This method initializes JLabelTime	
     * 	
     * @return javax.swing.JLabel	
     */
    private JLabel getJLabelTime() {
        if (jLabelTime == null) {
        	jLabelTime = new JLabel("00:00:00");
        }
        return jLabelTime;
    }

    /**
     * This method initializes JLabelTime	
     * 	
     */
    protected void setJLabelTime(String time) {
        if (jLabelTime != null) {
        	jLabelTime.setText(time);
        }
     }

    /**
     * This method initializes jSliderSearch	
     * 	
     * @return javax.swing.JSlider	
     */
    private JSlider getJSliderSearch() {
        if (jSliderSearch == null) {
            jSliderSearch = new JSlider();
            setJSliderSearchLength(0);
       }
        return jSliderSearch;
    }

    /**
    * Method setJSliderSearchLength.
    * <br><b>Summary:</b><br>
    * Set the slider graduation according to the video length.
    * @param videoLength The <b>int</b> video time in second
     */
    protected void setJSliderSearchLength(int videoLength) {
        if (jSliderSearch != null) {
        	jSliderSearch.setMaximum(videoLength);
            jSliderSearch.setMajorTickSpacing(videoLength/4);
            jSliderSearch.setMinorTickSpacing(videoLength/16);
            jSliderSearch.setPaintTicks(true);
            jSliderSearch.setPaintLabels(true);
            // Create the label table
            Hashtable<Integer, JLabel> labelTable = new Hashtable<Integer, JLabel>();
            labelTable.put( new Integer( 0 ), new JLabel("00:00:00") );
            labelTable.put( new Integer( videoLength / 4 ), new JLabel(Utils.formatTime(videoLength / 4)) );
            labelTable.put( new Integer( videoLength / 2 ), new JLabel(Utils.formatTime(videoLength / 2)) );
            labelTable.put( new Integer( (videoLength / 4) * 3 ), new JLabel(Utils.formatTime((videoLength / 4) * 3)) );
            labelTable.put( new Integer( videoLength ), new JLabel(Utils.formatTime(videoLength)) );
            jSliderSearch.setLabelTable( labelTable );
       }
    }

    /**
     * Method setJSliderSearchListener.
     * <br><b>Summary:</b><br>
     * Permits to add a change listener to the JSlider.
     * @param listener      The changeListener to add to the JSlider.
     */
    protected void setJSliderSearchListener(ChangeListener listener) {
        if (jSliderSearch != null) {
        	jSliderSearch.addChangeListener(listener);
       }
    }

    /**
    * Method setJSliderSearchPosition.
    * <br><b>Summary:</b><br>
    * Set the slider position according to the video position.
    * @param position The <b>int</b> video position in second
     */
    protected void setJSliderSearchPosition(int position) {
        if (jSliderSearch != null) {
        	jSliderSearch.setValue(position);
       }
    }

    /**
     * This method initializes jCheckBoxTrackMode	
     * 	
     * @return javax.swing.JCheckBox	
     */
    private JCheckBox getJCheckBoxTrackMode() {
        if (jCheckBoxTrackMode == null) {
            jCheckBoxTrackMode = new JCheckBox(MainWindow.instance.getAction(MainWindow.ACTION_KEY_TRACKER_TRIGGER));
        }
        return jCheckBoxTrackMode;
    }

    /**
     * This method initializes jCheckBoxTrackMode	
     * 	
     * @return javax.swing.JCheckBox	
     */
    protected boolean jCheckBoxTrackModeIsSelected() {
    	boolean isSelected = false;
        if (jCheckBoxTrackMode != null) {
        	isSelected = jCheckBoxTrackMode.isSelected();
        }
        return isSelected;
    }

    /**
     * This method initializes jPanelStopPlay	
     * 	
     * @return javax.swing.JPanel	
     */
    private JPanel getJPanelStopPlay() {
        if (jPanelStopPlay == null) {
            GridBagConstraints gridBagConstraints111 = new GridBagConstraints();
            gridBagConstraints111.gridx = 0;
            gridBagConstraints111.gridy = 0;
           GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
            gridBagConstraints11.gridx = 2;
            gridBagConstraints11.gridy = 0;
            GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
            gridBagConstraints1.gridx = 3;
            gridBagConstraints1.ipadx = 0;
            gridBagConstraints1.anchor = GridBagConstraints.EAST;
            gridBagConstraints1.fill = GridBagConstraints.NONE;
            gridBagConstraints1.gridy = -1;
            GridBagConstraints gridBagConstraints = new GridBagConstraints();
            gridBagConstraints.gridx = -1;
            gridBagConstraints.anchor = GridBagConstraints.WEST;
            gridBagConstraints.gridy = -1;
            jPanelStopPlay = new JPanel();
            jPanelStopPlay.setLayout(new GridBagLayout());
            jPanelStopPlay.add(getJButtonOpenVideo(), gridBagConstraints111);
            jPanelStopPlay.add(getJButtonStop(), gridBagConstraints);
            jPanelStopPlay.add(getJButtonPlay(), gridBagConstraints1);
            jPanelStopPlay.add(getJButtonPause(), gridBagConstraints11);
        }
        return jPanelStopPlay;
    }

    /**
     * This method initializes jPanelPreviousNext	
     * 	
     * @return javax.swing.JPanel	
     */
    private JPanel getJPanelPreviousNext() {
        if (jPanelPreviousNext == null) {
            GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
            gridBagConstraints4.gridx = -1;
            gridBagConstraints4.anchor = GridBagConstraints.WEST;
            gridBagConstraints4.fill = GridBagConstraints.NONE;
            gridBagConstraints4.gridy = -1;
            GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
            gridBagConstraints3.fill = GridBagConstraints.VERTICAL;
            gridBagConstraints3.gridy = -1;
            gridBagConstraints3.weightx = 1.0;
            gridBagConstraints3.anchor = GridBagConstraints.WEST;
            gridBagConstraints3.gridx = -1;
            GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
            gridBagConstraints2.gridx = -1;
            gridBagConstraints2.anchor = GridBagConstraints.WEST;
            gridBagConstraints2.gridy = -1;
            jPanelPreviousNext = new JPanel();
            jPanelPreviousNext.setLayout(new GridBagLayout());
            jPanelPreviousNext.add(getJButtonPrevious(), gridBagConstraints2);
            jPanelPreviousNext.add(getJSpinnerTimeStep(), gridBagConstraints3);
            jPanelPreviousNext.add(getJButtonNext(), gridBagConstraints4);
        }
        return jPanelPreviousNext;
    }

    /**
     * This method initializes jButtonPause	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getJButtonPause() {
        if (jButtonPause == null) {
            jButtonPause = new JButton(MainWindow.instance.getAction(MainWindow.ACTION_KEY_PAUSE));
            jButtonPause.setText("");
        }
        return jButtonPause;
    }
    
    /**
     * Method getTimeStep.
     * <br><b>Summary:</b><br>
     * This method return the selected time step.
     * @return  int     The selected time step.
     */
    protected int getTimeStep(){
        //The result of the method.
        int result = 10;
        //get the selected value in the JSPinner.
        result = ((Integer) getJSpinnerTimeStep().getValue()).intValue();
        //return the result
        return result;
    }
}
