//////////////////////////////////////////////////
// This file is part of Sears project.
// Subtitle Editor And Re-Synch
// A tool to easily modify and resynch movies subtitles.
/////////////////////////////////////////////////
//This program is free software; 
//you can redistribute it and/or modify it under the terms 
//of the GNU General Public License 
//as published by the Free Software Foundation; 
//either version 2 of the License, or (at your option) any later version.
/////////////////////////////////////////////////
//Sears project is available under sourceforge
// at adress: http://sourceforge.net/projects/sears/
//Copyright (C) 2005 Booba Skaya
//Mail: booba.skaya@gmail.com
////////////////////////////////////////////////
package sears.gui;

import java.awt.Component;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;

import sears.gui.resources.SearsResources;

/**
 *
 */
public class SubtitleAnchorHeaderTableCellRenderer extends
		DefaultTableCellRenderer {
	
	/** (<b>long</b>) serialVersionUID: The serialVersionUID */
	private static final long serialVersionUID = -5783426661310517302L;
	
	/** (<b>ImageIcon</b>) anchorIcon: The anchorIcon */
	private static ImageIcon anchorIcon;

	private TableCellRenderer oldHeaderRenderer;

	/**
	 * Constructs a new renderer for table hearder
	 * @param headerRenderer	the table header renderer
	 */
	public SubtitleAnchorHeaderTableCellRenderer(TableCellRenderer headerRenderer) {
		oldHeaderRenderer = headerRenderer;
	}

	/**
	 * Method getAnchorIcon. <br>
	 * <b>Summary:</b><br>
	 * Return the anchor icon. Use a cache to increase performance since the
	 * anchor icon is always the same.
	 * 
	 * @return (<b>Icon</b>) The anchor icon.
	 */
	private Icon getAnchorIcon() {
		if (anchorIcon == null) {
			anchorIcon = SearsResources.getIcon("AnchorIcon");
		}
		return anchorIcon;
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.DefaultTableCellRenderer#getTableCellRendererComponent(javax.swing.JTable, java.lang.Object, boolean, boolean, int, int)
	 */
	@Override
	public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
		Component result =  oldHeaderRenderer.getTableCellRendererComponent(table, value, isSelected, hasFocus,
				row, column);
		if(column == SubtitleTableModel.ANCHOR_COLUMN){
			((JLabel) result).setIcon(getAnchorIcon());
		}else{
			((JLabel) result).setIcon(null);
		}
		return result;
	}

	
	
}
