/////////////////////////////////////////////////
//This file is part of Sears project.
//Subtitle Editor And Re-Synch
//A tool to easily modify and resynch movies subtitles.
/////////////////////////////////////////////////
//This program is free software; 
//you can redistribute it and/or modify it under the terms 
//of the GNU General Public License 
//as published by the Free Software Foundation; 
//either version 2 of the License, or (at your option) any later version.
/////////////////////////////////////////////////
//Sears project is available under sourceforge
//at adress: http://sourceforge.net/projects/sears/
//Copyright (C) 2005 Booba Skaya
//Mail: booba.skaya@gmail.com
/////////////////////////////////////////////////

// some suggestions about this class: floriaen@gmail.com

package sears.gui.glassPane;

import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;

/**
 * Allows to a <code>ViewportGlassPane</code> object to have alerts when it's viewport 
 * is resized
 */
class ViewportListener extends ComponentAdapter {
	
	private ViewportGlassPane vgp;
	
	/**
	 * Constructs a new instance with a <code>ViewportGlassPane</code> object as the only parameters
	 * @param glassPane the <code>ViewportGlassPane</code> object to alert of its viewport state
	 * @throws			NullPointerException if glassPane is null
	 */
	public ViewportListener(ViewportGlassPane glassPane) {
		if( glassPane == null ) {
			throw new NullPointerException("ViewportGlassPane object cannot be null");
		}
		vgp = glassPane;
	}

	/*
	 * (non-Javadoc)
	 * @see java.awt.event.ComponentAdapter#componentResized(java.awt.event.ComponentEvent)
	 */
	public void componentResized(ComponentEvent e) {
		if( vgp != null ) {
			vgp.fireViewportSizeChanged();
		}
	}
}