/////////////////////////////////////////////////
//This file is part of Sears project.
//Subtitle Editor And Re-Synch
//A tool to easily modify and resynch movies subtitles.
/////////////////////////////////////////////////
//This program is free software; 
//you can redistribute it and/or modify it under the terms 
//of the GNU General Public License 
//as published by the Free Software Foundation; 
//either version 2 of the License, or (at your option) any later version.
/////////////////////////////////////////////////
//Sears project is available under sourceforge
//at adress: http://sourceforge.net/projects/sears/
//Copyright (C) 2005 Booba Skaya
//Mail: booba.skaya@gmail.com
/////////////////////////////////////////////////

// some suggestions about this class: floriaen@gmail.com

package sears.gui.glassPane.element;

import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Shape;

/**
 * <code>GPShape</code> offers manipulations controls on a define <code>Shape</code> object.
 * ( ... )
 * @see Shape
 * @see Graphics2D
 */
public interface GPShape {

	/**
	 * Translates the <code>GPShape</code> object to the new given coordinates.
	 * @param x the new x coordinates.
	 * @param y the new y coordinates.
	 */
	public void translate(int x, int y);
	
	/**
	 * Translates the <code>GPShape</code> object to the new given point location.
	 * @param point the new point location
	 */
	public void translate(Point point);
	
	/**
	 * Returns a <code>Shape</code> object that represents the abstract bounds 
	 * of the <code>GPShape</code>
	 * <br>This shape could be the real bounds, an aproximation 
	 * (like a rectangle that enclose entirely the GPShape) or a part of the GPShape.
	 * <br>It's depends to the implementation.
	 * 
	 * @return the shape bounds
	 */
	public Shape getBounds();
	
	/**
	 * Paint the <code>GPShape</code> using the graphics context given in parameters
	 * @param gr the graphics context
	 */
	public void paint(Graphics2D gr);
}