package sears.gui.search;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.KeyListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JTextField;
import javax.swing.event.CaretListener;

import sears.gui.resources.SearsResources;

public class JSearchField extends JComponent {

	/**
	 * 
	 */
	private static final long serialVersionUID = -8471752029617130242L;
	private static final Icon FIND_ICON = SearsResources.getIcon("TinyFindIcon");
	private static final int LEFT_BORDER = 6;
	
	private JTextField _text;
	
	public JSearchField() {
		super();		
		initComponents();
	}
	
	private void initComponents() {
//		Border bd = BorderFactory.
		
		
		this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		//this.setBackground(Color.WHITE);
		
		//this.setOpaque(true);
	//	this.setBorder(BorderFactory.createEmptyBorder(4, 4, 4, 4));
		_text = new JTextField();
		//_text.setBorder(BorderFactory.createEmptyBorder());
		
		Component bx = Box.createHorizontalStrut(FIND_ICON.getIconWidth() + LEFT_BORDER*2);
		bx.setBackground(Color.WHITE);
		this.add(bx);
		this.add(_text);
		this.add(Box.createHorizontalStrut(12));
	}

	public void paint(Graphics gr) {
		//super.paint(gr);
		Graphics2D g = (Graphics2D) gr;
		/*Color oc = g.getColor();
		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON );
		g.setColor(Color.WHITE);
		g.fillRoundRect(0, 1, _text.getWidth()+_text.getX()+10, _text.getHeight()-2, this.getHeight(), this.getHeight());
		*/
		super.paint(g);
		/*
		g.setColor(Color.GRAY);
		g.drawRoundRect(0, 1, _text.getWidth()+_text.getX()+10, _text.getHeight()-2, this.getHeight(), this.getHeight());
		g.setColor(oc);
		//System.out.println(this.getWidth());*/
		
		// centered coordonates:
		int cy = this.getY() + (_text.getHeight()-FIND_ICON.getIconHeight())/2;
		int cx = this.getX()+LEFT_BORDER;
		FIND_ICON.paintIcon(this, g,cx , cy);
		//_text.setBounds(20, 0, 
		//g.translate(cx+FIND_ICON.getIconWidth()+LEFT_BORDER, 0);
		//_text.setSize(this.getWidth() - 30, this.getHeight());
	//	_text.paint(g);
		//_text.setLocation(this.getX()+30, 0);		
	}
	
	public void addCaretListener(CaretListener listener) {
		_text.addCaretListener(listener);
	}
	
	
	public void addKeyListener(KeyListener listener) {
		_text.addKeyListener(listener);
	}
	
	public String getText() {
		return _text.getText();
	}
	
	public void setEnabled(boolean enabled) {
		_text.setEnabled(enabled);
	}
	
}
