/////////////////////////////////////////////////
// This file is part of Sears project.
// Subtitle Editor And Re-Synch
// A tool to easily modify and resynch movies subtitles.
/////////////////////////////////////////////////
//This program is free software; 
//you can redistribute it and/or modify it under the terms 
//of the GNU General Public License 
//as published by the Free Software Foundation; 
//either version 2 of the License, or (at your option) any later version.
/////////////////////////////////////////////////
//Sears project is available under sourceforge
// at adress: http://sourceforge.net/projects/sears/
//Copyright (C) 2005 Booba Skaya
//Mail: booba.skaya@gmail.com
////////////////////////////////////////////////
package sears.junit.file;

import java.io.IOException;
import java.util.ArrayList;

import sears.file.SrtFile;
import sears.file.Subtitle;
import junit.framework.TestCase;

/**
 * Class SrtFileTest.
 * <br><b>Summary:</b><br>
 * Junit tests for class SrtFile.
 */
public class SrtFileTest extends TestCase {
    /*
     * Test method for 'sears.file.SrtFile.writeToFile(File)'
     */
    public void testWriteToFile() {
    }

    /*
     * Test method for 'sears.file.SrtFile.writeToTemporaryFile()'
     */
    public void testWriteToTemporaryFile() {
    }

    /*
     * Test method for 'sears.file.SrtFile.SrtFile()'
     */
    public void testSrtFile() {
    }

    /*
     * Test method for 'sears.file.SrtFile.SrtFile(File, ArrayList)'
     */
    public void testSrtFileFileArrayList() {
        //test with a space lined file.
        ArrayList<Subtitle> subtitleList = new ArrayList<Subtitle>();
        try {
			new SrtFile(SubtitleFileTest.class.getResource("spaceLined.srt").getFile(), subtitleList);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        //Check that file has been correctly parsed.
        //there must be 5 ST in the list.
        assertTrue(subtitleList.size() == 5);
        //check all subtitles.
        SubtitleFileTest.assertSubtitleEqualsTo(subtitleList, 0, 1, 0, 1000, "Le premier sous titre.\n");
        SubtitleFileTest.assertSubtitleEqualsTo(subtitleList, 1, 2, 2000, 3000, "Le deuxieme sous titre.\n");
        SubtitleFileTest.assertSubtitleEqualsTo(subtitleList, 2, 3, 4000, 5555, "hop hop !\n");
        SubtitleFileTest.assertSubtitleEqualsTo(subtitleList, 3, 4, 7000, 9000, "sabotes, kidnappes, assassines.\n");
        SubtitleFileTest.assertSubtitleEqualsTo(subtitleList, 4, 5, 10000, 11000, "Nous ne sommes pas seuls sur cette ile.\n");
    }

    /*
     * Test method for 'sears.file.SrtFile.SrtFile(String, ArrayList)'
     */
    public void testSrtFileStringArrayList() {
    }
}
