/////////////////////////////////////////////////
// This file is part of Sears project.
// Subtitle Editor And Re-Synch
// A tool to easily modify and resynch movies subtitles.
/////////////////////////////////////////////////
//This program is free software; 
//you can redistribute it and/or modify it under the terms 
//of the GNU General Public License 
//as published by the Free Software Foundation; 
//either version 2 of the License, or (at your option) any later version.
/////////////////////////////////////////////////
//Sears project is availbale under sourceforge
// at adress: http://sourceforge.net/projects/sears/
//Copyright (C) 2005 Booba Skaya
//Mail: booba.skaya@gmail.com
////////////////////////////////////////////////
package sears.tools;

import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.KeyStroke;
import sears.gui.resources.SearsResources;

/**
 * Class SearsAction.
 * <br><b>Summary:</b><br>
 * This class is an action for Sears.
 * It is composed by a message, a tool tip and an icon.
 * Use the resource facility to retrieve infos.
 */
public abstract class SearsAction extends AbstractAction {
    /** Default Serial UID*/
	private static final long serialVersionUID = 1L;

	public SearsAction(String actionTag) {
        super();
        //Set action name
        String name = //SearsResourceBundle.getString(actionTag + "Name");
            SearsResourceBundle.getResource(actionTag + "Name");
        if (name != null) {
            putValue(NAME, name);
        }
        //Set action tool tip/
        String tip = //SearsResourceBundle.getString(actionTag + "Tip");
            SearsResourceBundle.getResource(actionTag + "Tip");
        if (tip != null) {
            putValue(SHORT_DESCRIPTION, tip);
        }
        //Set action icon/
        ImageIcon icon= SearsResources.getIcon(actionTag + "Icon");
        if (icon != null) {
            putValue(SMALL_ICON, icon);
        }
        //set a shortKey
        KeyStroke key = SearsResources.getKey(actionTag+"Key");
        if(key != null){
            putValue(ACCELERATOR_KEY, key);
        }
    }
}
