/////////////////////////////////////////////////
//This file is part of Sears project.
//Subtitle Editor And Re-Synch
//A tool to easily modify and resynch movies subtitles.
/////////////////////////////////////////////////
//This program is free software; 
//you can redistribute it and/or modify it under the terms 
//of the GNU General Public License 
//as published by the Free Software Foundation; 
//either version 2 of the License, or (at your option) any later version.
/////////////////////////////////////////////////
//Sears project is available under sourceforge
//at adress: http://sourceforge.net/projects/sears/
//Copyright (C) 2005 Booba Skaya
//Mail: booba.skaya@gmail.com
/////////////////////////////////////////////////

//////////////////////////////////////////////////////
// this file comes from the EawtWrapper librairie 	//
// information: www.daem0n.fr/eawt 					//
//////////////////////////////////////////////////////

package sears.tools.eawt;

/**
 * <u>com.apple.eawt.ApplicationListener</u>
 * The listener interface for receiving ApplicationEvents.
 */
public interface ApplicationListener {
	
	/**
	 * <u>com.apple.eawt.ApplicationListener#handleAbout(com.apple.eawt.ApplicationEvent)</u>
	 * <br>Called when the user selects the About item in the application menu.
	 * @param event an ApplicationEvent initiated by the user choosing About in the application menu
	 */
	public void handleAbout(Object event);

	/**
	 * <u>com.apple.eawt.ApplicationListener#handleOpenApplication(com.apple.eawt.ApplicationEvent)</u>
	 * <br>Called when the application receives an Open Application event from the Finder or another application.
	 * @param event the Open Application event
	 */
	public void handleOpenApplication(Object event);

	/**
	 * <u>com.apple.eawt.ApplicationListener#handleOpenApplication(com.apple.eawt.ApplicationEvent)</u>
	 * <br>Called when the application receives an Open Document event from the Finder or another application.
	 * @param event an Open Document event with reference to the file to be opened
	 */
	public void handleOpenFile(Object event);

	/**
	 * <u>com.apple.eawt.ApplicationListener#handlePreferences(com.apple.eawt.ApplicationEvent)</u>
	 * <br>Called when the Preference item in the application menu is selected.
	 * @param event triggered when the user selects Preferences from the application menu
	 */
	public void handlePreferences(Object event);

	/**
	 * <u>com.apple.eawt.ApplicationListener#handlePrintFile(com.apple.eawt.ApplicationEvent)</u>
	 * <br>Called when the application is sent a request to print a particular file or files.
	 * @param event a Print Document event with a reference to the file(s) to be printed
	 */
	public void handlePrintFile(Object event);

	/**
	 * <u>com.apple.eawt.ApplicationListener#handleQuit(com.apple.eawt.ApplicationEvent)</u>
	 * <br>Called when the application is sent the Quit event.
	 * @param event a Quit Application event
	 */
	public void handleQuit(Object event);

	/**
	 * <u>com.apple.eawt.ApplicationListener#handleReOpenApplication(com.apple.eawt.ApplicationEvent)</u>
	 * <br>Called when the application receives a Reopen Application event from the Finder or another application.
	 * @param event the Reopen Application event
	 */
	public void handleReOpenApplication(Object event);
}