/////////////////////////////////////////////////
//This file is part of Sears project.
//Subtitle Editor And Re-Synch
//A tool to easily modify and resynch movies subtitles.
/////////////////////////////////////////////////
//This program is free software; 
//you can redistribute it and/or modify it under the terms 
//of the GNU General Public License 
//as published by the Free Software Foundation; 
//either version 2 of the License, or (at your option) any later version.
/////////////////////////////////////////////////
//Sears project is available under sourceforge
//at adress: http://sourceforge.net/projects/sears/
//Copyright (C) 2005 Booba Skaya
//Mail: booba.skaya@gmail.com
/////////////////////////////////////////////////

package sears.tools.eawt;

/**
 * <tt>SearsApp</tt> allows Sears to have a good integration on Mac OS X,
 * allows Sears to use java API delivery by Apple (especially classes in eawt package)
 */
public class SearsApp {
	// the singleton instance of Application:
	private static ApplicationWrapper searsApp;

	/**
	 * Creates a new object
	 * @throws AppException if searsApp object could not be created
	 */
	public SearsApp() throws AppException {
		if( searsApp == null ) {
			searsApp = ApplicationWrapper.getApplication();
		}

		// no needed at this time, see Main class:
		setPreferences();
		searsApp.addPreferencesMenuItem();
		searsApp.setEnabledPreferencesMenu(true);
		searsApp.addApplicationListener(
				ApplicationListenerHandler.getWrappedApplicationListenerInstance(
						new SearsApplicationListener()));
	}

	/**
	 * this method set preferences to Sears:
	 * <br> - apple.laf.useScreenMenuBar to true
	 * <br> - apple.awt.showGrowBox to true
	 */
	private static void setPreferences(){
		// set the menu bar on the top of the screen,
		// if default style "apple.laf.AquaLookAndFeel" has changed by user,
		// the menu bar returns on the top of the main JFrame.
		System.setProperty( "apple.laf.useScreenMenuBar", "true" );
		// others properties:
		System.setProperty( "apple.awt.showGrowBox", "true" );
		System.setProperty( "apple.awt.textantialiasing" , "true" );
	}
}